/* 
** Objects of this class store place-local data, and are accessed via PLH.
*/

import x10.util.*;

class InfosPerPlace {

  var sqsOfOnePlace: Rail[SplitQueue];
  val paras: Paras;  // replicated to each place for fast access
  var nPlace: Long = 0;   // result number of tree nodes at this place (used in reduction in Uts.x10)

  // paras must be set in constructor (not in init), since init can not overwrite a val parameter
  def this(paras: Paras) {
    this.paras = paras;   // replicates paras to all places
  }

  //  Since init is called after PlaceLocalHandle.make, tp was already initialized.
  def init(tp: PlaceLocalHandle[InfosPerPlace]) {
    this.sqsOfOnePlace = new Rail[SplitQueue](paras.numWorkersPerPlace,
                                               (i:long) => new SplitQueue(paras.privateSize, 
                                                                              paras.publicSize, 
                                                                              i,
                                                                              tp));
  }

}